Index: branches/New Persistence Exploration/Persistence/Persistence/CompoundSerializers.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/CompoundSerializers.cs	(revision 1313)
+++ branches/New Persistence Exploration/Persistence/Persistence/CompoundSerializers.cs	(revision 1314)
@@ -5,5 +5,5 @@
 namespace Persistence {
 
-  public interface ICustomSerializer {
+  public interface ICompoundSerializer {
     bool CanSerialize(Type type);
     IEnumerable Serialize(object o);
@@ -11,5 +11,5 @@
   }
 
-  public class EnumerableSerializer : ICustomSerializer {
+  public class EnumerableSerializer : ICompoundSerializer {
     public bool CanSerialize(Type type) {
       if (type.GetInterface("IEnumerable") == null)
@@ -36,5 +36,5 @@
   }
 
-  public class ArraySerializer : ICustomSerializer {
+  public class ArraySerializer : ICompoundSerializer {
 
     public bool CanSerialize(Type type) {      
Index: branches/New Persistence Exploration/Persistence/Persistence/DeSerializer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/DeSerializer.cs	(revision 1313)
+++ branches/New Persistence Exploration/Persistence/Persistence/DeSerializer.cs	(revision 1314)
@@ -62,5 +62,5 @@
 
     private Dictionary<Type, IPrimitiveSerializer> primitiveSerializers;
-    private List<ICustomSerializer> customSerializers;
+    private List<ICompoundSerializer> customSerializers;
 
     delegate void Thunk();
@@ -69,5 +69,5 @@
     public DeSerializer(
         IEnumerable<IPrimitiveSerializer> primitiveSerializers,
-        IEnumerable<ICustomSerializer> customSerializers) {
+        IEnumerable<ICompoundSerializer> customSerializers) {
       id2obj = new Dictionary<int, object>();
       compositeStack = new Stack<IAccessibleObject>();
@@ -82,5 +82,5 @@
         this.primitiveSerializers.Add(ps.Type, ps);
       }
-      this.customSerializers = new List<ICustomSerializer>(customSerializers);
+      this.customSerializers = new List<ICompoundSerializer>(customSerializers);
       this.finalFixes = new List<Thunk>();
     }
@@ -112,5 +112,5 @@
     private void CompositeEndHandler(IParseToken token) {
       CompositeEnd end = (CompositeEnd)token;
-      ICustomSerializer customSerializer = this.FindCustomSerializer(end.Type);
+      ICompoundSerializer customSerializer = this.FindCustomSerializer(end.Type);
       if (customSerializer != null) {
         CustomObject customObject = (CustomObject)compositeStack.Pop();
@@ -124,6 +124,6 @@
       }
     }
-    private ICustomSerializer FindCustomSerializer(Type type) {
-      foreach (ICustomSerializer serializer in customSerializers) {
+    private ICompoundSerializer FindCustomSerializer(Type type) {
+      foreach (ICompoundSerializer serializer in customSerializers) {
         if (serializer.CanSerialize(type))
           return serializer;
Index: branches/New Persistence Exploration/Persistence/Persistence/NewSerializationTest.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/NewSerializationTest.cs	(revision 1313)
+++ branches/New Persistence Exploration/Persistence/Persistence/NewSerializationTest.cs	(revision 1314)
@@ -60,5 +60,5 @@
           new Double2XmlSerializer(),
         },
-        new ICustomSerializer[] { 
+        new ICompoundSerializer[] { 
           new ArraySerializer(),
           new EnumerableSerializer() });
Index: branches/New Persistence Exploration/Persistence/Persistence/Serializer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Serializer.cs	(revision 1313)
+++ branches/New Persistence Exploration/Persistence/Persistence/Serializer.cs	(revision 1314)
@@ -11,5 +11,5 @@
     private Dictionary<object, int> obj2id;
     private Dictionary<Type, IPrimitiveSerializer> primitiveSerializers;
-    private List<ICustomSerializer> customSerializers;
+    private List<ICompoundSerializer> customSerializers;
 
     public Serializer(object obj, IEnumerable<IPrimitiveSerializer> primitiveSerializers) :
@@ -23,5 +23,5 @@
         this.primitiveSerializers.Add(serializer.Type, serializer);
       }
-      this.customSerializers = new List<ICustomSerializer>();
+      this.customSerializers = new List<ICompoundSerializer>();
       customSerializers.Add(new EnumerableSerializer());
       customSerializers.Add(new ArraySerializer());
@@ -54,5 +54,5 @@
         this.obj2id.Add(value, id);
         yield return new BeginToken(accessor, id);
-        ICustomSerializer customSerializer = this.FindCustomSerializer(value.GetType());
+        ICompoundSerializer customSerializer = this.FindCustomSerializer(value.GetType());
         if (customSerializer != null) {
           foreach (object obj in customSerializer.Serialize(value)) {
@@ -73,6 +73,6 @@
     }
 
-    private ICustomSerializer FindCustomSerializer(Type type) {
-      foreach (ICustomSerializer s in customSerializers) {
+    private ICompoundSerializer FindCustomSerializer(Type type) {
+      foreach (ICompoundSerializer s in customSerializers) {
         if (s.CanSerialize(type))
           return s;