Index: trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.Designer.cs	(revision 1242)
+++ trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.Designer.cs	(revision 1328)
@@ -24,37 +24,122 @@
     /// </summary>
     private void InitializeComponent() {
-      this.Optionstabs = new System.Windows.Forms.TabControl();
-      this.tabPage1 = new System.Windows.Forms.TabPage();
-      this.OptionsDialogSelectColorBt = new System.Windows.Forms.Button();
-      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
-      this.label2 = new System.Windows.Forms.Label();
-      this.LinestyleCB = new System.Windows.Forms.ComboBox();
-      this.label1 = new System.Windows.Forms.Label();
-      this.LineSelectCB = new System.Windows.Forms.ComboBox();
-      this.groupBox1 = new System.Windows.Forms.GroupBox();
-      this.label4 = new System.Windows.Forms.Label();
-      this.LineThicknessCB = new System.Windows.Forms.ComboBox();
-      this.label3 = new System.Windows.Forms.Label();
-      this.tabPage2 = new System.Windows.Forms.TabPage();
-      this.labelposition = new System.Windows.Forms.Label();
-      this.cbLabelPosition = new System.Windows.Forms.ComboBox();
       this.OptionsDialogCancelButton = new System.Windows.Forms.Button();
       this.OptionsDialogOkButton = new System.Windows.Forms.Button();
       this.OptionsDialogApplyBtn = new System.Windows.Forms.Button();
-      this.Optionstabs.SuspendLayout();
+      this.fdFont = new System.Windows.Forms.FontDialog();
+      this.tpTitle = new System.Windows.Forms.TabPage();
+      this.btnChangeTitleFont = new System.Windows.Forms.Button();
+      this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.cbLabelPosition = new System.Windows.Forms.ComboBox();
+      this.labelposition = new System.Windows.Forms.Label();
+      this.tabPage1 = new System.Windows.Forms.TabPage();
+      this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.label3 = new System.Windows.Forms.Label();
+      this.LineThicknessCB = new System.Windows.Forms.ComboBox();
+      this.label4 = new System.Windows.Forms.Label();
+      this.LineSelectCB = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.LinestyleCB = new System.Windows.Forms.ComboBox();
+      this.label2 = new System.Windows.Forms.Label();
+      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
+      this.OptionsDialogSelectColorBt = new System.Windows.Forms.Button();
+      this.Optionstabs = new System.Windows.Forms.TabControl();
+      this.btnChangeLegendFont = new System.Windows.Forms.Button();
+      this.tpTitle.SuspendLayout();
+      this.tabPage2.SuspendLayout();
       this.tabPage1.SuspendLayout();
       this.groupBox1.SuspendLayout();
-      this.tabPage2.SuspendLayout();
+      this.Optionstabs.SuspendLayout();
       this.SuspendLayout();
       // 
-      // Optionstabs
-      // 
-      this.Optionstabs.Controls.Add(this.tabPage1);
-      this.Optionstabs.Controls.Add(this.tabPage2);
-      this.Optionstabs.Location = new System.Drawing.Point(0, 1);
-      this.Optionstabs.Name = "Optionstabs";
-      this.Optionstabs.SelectedIndex = 0;
-      this.Optionstabs.Size = new System.Drawing.Size(292, 225);
-      this.Optionstabs.TabIndex = 0;
+      // OptionsDialogCancelButton
+      // 
+      this.OptionsDialogCancelButton.Location = new System.Drawing.Point(213, 232);
+      this.OptionsDialogCancelButton.Name = "OptionsDialogCancelButton";
+      this.OptionsDialogCancelButton.Size = new System.Drawing.Size(75, 23);
+      this.OptionsDialogCancelButton.TabIndex = 1;
+      this.OptionsDialogCancelButton.Text = "Cancel";
+      this.OptionsDialogCancelButton.UseVisualStyleBackColor = true;
+      this.OptionsDialogCancelButton.Click += new System.EventHandler(this.OptionsDialogCancelButton_Click);
+      // 
+      // OptionsDialogOkButton
+      // 
+      this.OptionsDialogOkButton.Location = new System.Drawing.Point(43, 232);
+      this.OptionsDialogOkButton.Name = "OptionsDialogOkButton";
+      this.OptionsDialogOkButton.Size = new System.Drawing.Size(75, 23);
+      this.OptionsDialogOkButton.TabIndex = 2;
+      this.OptionsDialogOkButton.Text = "OK";
+      this.OptionsDialogOkButton.UseVisualStyleBackColor = true;
+      this.OptionsDialogOkButton.Click += new System.EventHandler(this.OptionsDialogOkButton_Click);
+      // 
+      // OptionsDialogApplyBtn
+      // 
+      this.OptionsDialogApplyBtn.Location = new System.Drawing.Point(128, 231);
+      this.OptionsDialogApplyBtn.Name = "OptionsDialogApplyBtn";
+      this.OptionsDialogApplyBtn.Size = new System.Drawing.Size(75, 23);
+      this.OptionsDialogApplyBtn.TabIndex = 3;
+      this.OptionsDialogApplyBtn.Text = "Apply";
+      this.OptionsDialogApplyBtn.UseVisualStyleBackColor = true;
+      this.OptionsDialogApplyBtn.Click += new System.EventHandler(this.OptionsDialogApplyBtn_Click);
+      // 
+      // fdFont
+      // 
+      this.fdFont.ShowColor = true;
+      // 
+      // tpTitle
+      // 
+      this.tpTitle.Controls.Add(this.btnChangeTitleFont);
+      this.tpTitle.Location = new System.Drawing.Point(4, 22);
+      this.tpTitle.Name = "tpTitle";
+      this.tpTitle.Size = new System.Drawing.Size(284, 199);
+      this.tpTitle.TabIndex = 2;
+      this.tpTitle.Text = "Title";
+      this.tpTitle.UseVisualStyleBackColor = true;
+      // 
+      // btnChangeTitleFont
+      // 
+      this.btnChangeTitleFont.Location = new System.Drawing.Point(3, 3);
+      this.btnChangeTitleFont.Name = "btnChangeTitleFont";
+      this.btnChangeTitleFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeTitleFont.TabIndex = 1;
+      this.btnChangeTitleFont.Text = "Change Font";
+      this.btnChangeTitleFont.UseVisualStyleBackColor = true;
+      this.btnChangeTitleFont.Click += new System.EventHandler(this.btnChangeTitleFont_Click);
+      // 
+      // tabPage2
+      // 
+      this.tabPage2.Controls.Add(this.btnChangeLegendFont);
+      this.tabPage2.Controls.Add(this.labelposition);
+      this.tabPage2.Controls.Add(this.cbLabelPosition);
+      this.tabPage2.Location = new System.Drawing.Point(4, 22);
+      this.tabPage2.Name = "tabPage2";
+      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage2.Size = new System.Drawing.Size(284, 199);
+      this.tabPage2.TabIndex = 1;
+      this.tabPage2.Text = "Legend";
+      this.tabPage2.UseVisualStyleBackColor = true;
+      // 
+      // cbLabelPosition
+      // 
+      this.cbLabelPosition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.cbLabelPosition.FormattingEnabled = true;
+      this.cbLabelPosition.Items.AddRange(new object[] {
+            "left",
+            "right",
+            "top",
+            "bottom"});
+      this.cbLabelPosition.Location = new System.Drawing.Point(81, 44);
+      this.cbLabelPosition.Name = "cbLabelPosition";
+      this.cbLabelPosition.Size = new System.Drawing.Size(121, 21);
+      this.cbLabelPosition.TabIndex = 0;
+      // 
+      // labelposition
+      // 
+      this.labelposition.AutoSize = true;
+      this.labelposition.Location = new System.Drawing.Point(3, 47);
+      this.labelposition.Name = "labelposition";
+      this.labelposition.Size = new System.Drawing.Size(72, 13);
+      this.labelposition.TabIndex = 1;
+      this.labelposition.Text = "Labelposition:";
       // 
       // tabPage1
@@ -75,59 +160,4 @@
       this.tabPage1.UseVisualStyleBackColor = true;
       // 
-      // OptionsDialogSelectColorBt
-      // 
-      this.OptionsDialogSelectColorBt.Location = new System.Drawing.Point(217, 126);
-      this.OptionsDialogSelectColorBt.Name = "OptionsDialogSelectColorBt";
-      this.OptionsDialogSelectColorBt.Size = new System.Drawing.Size(50, 23);
-      this.OptionsDialogSelectColorBt.TabIndex = 7;
-      this.OptionsDialogSelectColorBt.Text = "Select";
-      this.OptionsDialogSelectColorBt.UseVisualStyleBackColor = true;
-      this.OptionsDialogSelectColorBt.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
-      // 
-      // ColorPreviewTB
-      // 
-      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
-      this.ColorPreviewTB.Name = "ColorPreviewTB";
-      this.ColorPreviewTB.ReadOnly = true;
-      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
-      this.ColorPreviewTB.TabIndex = 6;
-      // 
-      // label2
-      // 
-      this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(36, 80);
-      this.label2.Name = "label2";
-      this.label2.Size = new System.Drawing.Size(30, 13);
-      this.label2.TabIndex = 3;
-      this.label2.Text = "Style";
-      // 
-      // LinestyleCB
-      // 
-      this.LinestyleCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LinestyleCB.FormattingEnabled = true;
-      this.LinestyleCB.Location = new System.Drawing.Point(146, 73);
-      this.LinestyleCB.Name = "LinestyleCB";
-      this.LinestyleCB.Size = new System.Drawing.Size(121, 21);
-      this.LinestyleCB.TabIndex = 2;
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(7, 37);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(72, 13);
-      this.label1.TabIndex = 1;
-      this.label1.Text = "Selected Line";
-      // 
-      // LineSelectCB
-      // 
-      this.LineSelectCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LineSelectCB.FormattingEnabled = true;
-      this.LineSelectCB.Location = new System.Drawing.Point(146, 30);
-      this.LineSelectCB.Name = "LineSelectCB";
-      this.LineSelectCB.Size = new System.Drawing.Size(121, 21);
-      this.LineSelectCB.TabIndex = 0;
-      this.LineSelectCB.SelectedIndexChanged += new System.EventHandler(this.LineSelectCB_SelectedIndexChanged);
-      // 
       // groupBox1
       // 
@@ -142,4 +172,22 @@
       this.groupBox1.Text = "Details";
       // 
+      // label3
+      // 
+      this.label3.AutoSize = true;
+      this.label3.Location = new System.Drawing.Point(32, 52);
+      this.label3.Name = "label3";
+      this.label3.Size = new System.Drawing.Size(56, 13);
+      this.label3.TabIndex = 5;
+      this.label3.Text = "Thickness";
+      // 
+      // LineThicknessCB
+      // 
+      this.LineThicknessCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LineThicknessCB.FormattingEnabled = true;
+      this.LineThicknessCB.Location = new System.Drawing.Point(142, 46);
+      this.LineThicknessCB.Name = "LineThicknessCB";
+      this.LineThicknessCB.Size = new System.Drawing.Size(121, 21);
+      this.LineThicknessCB.TabIndex = 4;
+      // 
       // label4
       // 
@@ -151,86 +199,79 @@
       this.label4.Text = "Color";
       // 
-      // LineThicknessCB
-      // 
-      this.LineThicknessCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LineThicknessCB.FormattingEnabled = true;
-      this.LineThicknessCB.Location = new System.Drawing.Point(142, 46);
-      this.LineThicknessCB.Name = "LineThicknessCB";
-      this.LineThicknessCB.Size = new System.Drawing.Size(121, 21);
-      this.LineThicknessCB.TabIndex = 4;
-      // 
-      // label3
-      // 
-      this.label3.AutoSize = true;
-      this.label3.Location = new System.Drawing.Point(32, 52);
-      this.label3.Name = "label3";
-      this.label3.Size = new System.Drawing.Size(56, 13);
-      this.label3.TabIndex = 5;
-      this.label3.Text = "Thickness";
-      // 
-      // tabPage2
-      // 
-      this.tabPage2.Controls.Add(this.labelposition);
-      this.tabPage2.Controls.Add(this.cbLabelPosition);
-      this.tabPage2.Location = new System.Drawing.Point(4, 22);
-      this.tabPage2.Name = "tabPage2";
-      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
-      this.tabPage2.Size = new System.Drawing.Size(284, 199);
-      this.tabPage2.TabIndex = 1;
-      this.tabPage2.Text = "Legend";
-      this.tabPage2.UseVisualStyleBackColor = true;
-      // 
-      // labelposition
-      // 
-      this.labelposition.AutoSize = true;
-      this.labelposition.Location = new System.Drawing.Point(8, 38);
-      this.labelposition.Name = "labelposition";
-      this.labelposition.Size = new System.Drawing.Size(72, 13);
-      this.labelposition.TabIndex = 1;
-      this.labelposition.Text = "Labelposition:";
-      // 
-      // cbLabelPosition
-      // 
-      this.cbLabelPosition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.cbLabelPosition.FormattingEnabled = true;
-      this.cbLabelPosition.Items.AddRange(new object[] {
-            "left",
-            "right",
-            "top",
-            "bottom"});
-      this.cbLabelPosition.Location = new System.Drawing.Point(86, 34);
-      this.cbLabelPosition.Name = "cbLabelPosition";
-      this.cbLabelPosition.Size = new System.Drawing.Size(121, 21);
-      this.cbLabelPosition.TabIndex = 0;
-      // 
-      // OptionsDialogCancelButton
-      // 
-      this.OptionsDialogCancelButton.Location = new System.Drawing.Point(213, 232);
-      this.OptionsDialogCancelButton.Name = "OptionsDialogCancelButton";
-      this.OptionsDialogCancelButton.Size = new System.Drawing.Size(75, 23);
-      this.OptionsDialogCancelButton.TabIndex = 1;
-      this.OptionsDialogCancelButton.Text = "Cancel";
-      this.OptionsDialogCancelButton.UseVisualStyleBackColor = true;
-      this.OptionsDialogCancelButton.Click += new System.EventHandler(this.OptionsDialogCancelButton_Click);
-      // 
-      // OptionsDialogOkButton
-      // 
-      this.OptionsDialogOkButton.Location = new System.Drawing.Point(43, 232);
-      this.OptionsDialogOkButton.Name = "OptionsDialogOkButton";
-      this.OptionsDialogOkButton.Size = new System.Drawing.Size(75, 23);
-      this.OptionsDialogOkButton.TabIndex = 2;
-      this.OptionsDialogOkButton.Text = "OK";
-      this.OptionsDialogOkButton.UseVisualStyleBackColor = true;
-      this.OptionsDialogOkButton.Click += new System.EventHandler(this.OptionsDialogOkButton_Click);
-      // 
-      // OptionsDialogApplyBtn
-      // 
-      this.OptionsDialogApplyBtn.Location = new System.Drawing.Point(128, 231);
-      this.OptionsDialogApplyBtn.Name = "OptionsDialogApplyBtn";
-      this.OptionsDialogApplyBtn.Size = new System.Drawing.Size(75, 23);
-      this.OptionsDialogApplyBtn.TabIndex = 3;
-      this.OptionsDialogApplyBtn.Text = "Apply";
-      this.OptionsDialogApplyBtn.UseVisualStyleBackColor = true;
-      this.OptionsDialogApplyBtn.Click += new System.EventHandler(this.OptionsDialogApplyBtn_Click);
+      // LineSelectCB
+      // 
+      this.LineSelectCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LineSelectCB.FormattingEnabled = true;
+      this.LineSelectCB.Location = new System.Drawing.Point(146, 30);
+      this.LineSelectCB.Name = "LineSelectCB";
+      this.LineSelectCB.Size = new System.Drawing.Size(121, 21);
+      this.LineSelectCB.TabIndex = 0;
+      this.LineSelectCB.SelectedIndexChanged += new System.EventHandler(this.LineSelectCB_SelectedIndexChanged);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(7, 37);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(72, 13);
+      this.label1.TabIndex = 1;
+      this.label1.Text = "Selected Line";
+      // 
+      // LinestyleCB
+      // 
+      this.LinestyleCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LinestyleCB.FormattingEnabled = true;
+      this.LinestyleCB.Location = new System.Drawing.Point(146, 73);
+      this.LinestyleCB.Name = "LinestyleCB";
+      this.LinestyleCB.Size = new System.Drawing.Size(121, 21);
+      this.LinestyleCB.TabIndex = 2;
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(36, 80);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(30, 13);
+      this.label2.TabIndex = 3;
+      this.label2.Text = "Style";
+      // 
+      // ColorPreviewTB
+      // 
+      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
+      this.ColorPreviewTB.Name = "ColorPreviewTB";
+      this.ColorPreviewTB.ReadOnly = true;
+      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
+      this.ColorPreviewTB.TabIndex = 6;
+      // 
+      // OptionsDialogSelectColorBt
+      // 
+      this.OptionsDialogSelectColorBt.Location = new System.Drawing.Point(217, 126);
+      this.OptionsDialogSelectColorBt.Name = "OptionsDialogSelectColorBt";
+      this.OptionsDialogSelectColorBt.Size = new System.Drawing.Size(50, 23);
+      this.OptionsDialogSelectColorBt.TabIndex = 7;
+      this.OptionsDialogSelectColorBt.Text = "Select";
+      this.OptionsDialogSelectColorBt.UseVisualStyleBackColor = true;
+      this.OptionsDialogSelectColorBt.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
+      // 
+      // Optionstabs
+      // 
+      this.Optionstabs.Controls.Add(this.tabPage1);
+      this.Optionstabs.Controls.Add(this.tabPage2);
+      this.Optionstabs.Controls.Add(this.tpTitle);
+      this.Optionstabs.Location = new System.Drawing.Point(0, 1);
+      this.Optionstabs.Name = "Optionstabs";
+      this.Optionstabs.SelectedIndex = 0;
+      this.Optionstabs.Size = new System.Drawing.Size(292, 225);
+      this.Optionstabs.TabIndex = 0;
+      // 
+      // btnChangeLegendFont
+      // 
+      this.btnChangeLegendFont.Location = new System.Drawing.Point(3, 6);
+      this.btnChangeLegendFont.Name = "btnChangeLegendFont";
+      this.btnChangeLegendFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeLegendFont.TabIndex = 2;
+      this.btnChangeLegendFont.Text = "Change Font";
+      this.btnChangeLegendFont.UseVisualStyleBackColor = true;
+      this.btnChangeLegendFont.Click += new System.EventHandler(this.btnChangeLegendFont_Click);
       // 
       // OptionsDialog
@@ -248,11 +289,12 @@
       this.Text = "OptionsDialog";
       this.Load += new System.EventHandler(this.OptionsDialog_Load);
-      this.Optionstabs.ResumeLayout(false);
+      this.tpTitle.ResumeLayout(false);
+      this.tabPage2.ResumeLayout(false);
+      this.tabPage2.PerformLayout();
       this.tabPage1.ResumeLayout(false);
       this.tabPage1.PerformLayout();
       this.groupBox1.ResumeLayout(false);
       this.groupBox1.PerformLayout();
-      this.tabPage2.ResumeLayout(false);
-      this.tabPage2.PerformLayout();
+      this.Optionstabs.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -261,22 +303,26 @@
     #endregion
 
-    private System.Windows.Forms.TabControl Optionstabs;
+    private System.Windows.Forms.Button OptionsDialogCancelButton;
+    private System.Windows.Forms.Button OptionsDialogOkButton;
+    private System.Windows.Forms.Button OptionsDialogApplyBtn;
+    private System.Windows.Forms.FontDialog fdFont;
+    private System.Windows.Forms.TabPage tpTitle;
+    private System.Windows.Forms.Button btnChangeTitleFont;
+    private System.Windows.Forms.TabPage tabPage2;
+    private System.Windows.Forms.Label labelposition;
+    private System.Windows.Forms.ComboBox cbLabelPosition;
     private System.Windows.Forms.TabPage tabPage1;
-    private System.Windows.Forms.TabPage tabPage2;
+    private System.Windows.Forms.Button OptionsDialogSelectColorBt;
+    private System.Windows.Forms.TextBox ColorPreviewTB;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.ComboBox LinestyleCB;
     private System.Windows.Forms.Label label1;
     private System.Windows.Forms.ComboBox LineSelectCB;
-    private System.Windows.Forms.Button OptionsDialogSelectColorBt;
-    private System.Windows.Forms.TextBox ColorPreviewTB;
+    private System.Windows.Forms.GroupBox groupBox1;
+    private System.Windows.Forms.Label label4;
+    private System.Windows.Forms.ComboBox LineThicknessCB;
     private System.Windows.Forms.Label label3;
-    private System.Windows.Forms.ComboBox LineThicknessCB;
-    private System.Windows.Forms.Label label2;
-    private System.Windows.Forms.ComboBox LinestyleCB;
-    private System.Windows.Forms.Label label4;
-    private System.Windows.Forms.GroupBox groupBox1;
-    private System.Windows.Forms.Button OptionsDialogCancelButton;
-    private System.Windows.Forms.Button OptionsDialogOkButton;
-    private System.Windows.Forms.ComboBox cbLabelPosition;
-    private System.Windows.Forms.Label labelposition;
-    private System.Windows.Forms.Button OptionsDialogApplyBtn;
+    private System.Windows.Forms.TabControl Optionstabs;
+    private System.Windows.Forms.Button btnChangeLegendFont;
   }
 }
Index: trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs	(revision 1242)
+++ trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs	(revision 1328)
@@ -6,8 +6,10 @@
   public partial class OptionsDialog : Form {
     private readonly IChartDataRowsModel model;
+    private readonly LineChart lineChart;
 
-    public OptionsDialog(IChartDataRowsModel model) {
+    public OptionsDialog(IChartDataRowsModel model, LineChart lineChart) {
       InitializeComponent();
       this.model = model;
+      this.lineChart = lineChart;
     }
 
@@ -41,9 +43,9 @@
       if (LineSelectCB.SelectedValue != null) {
         int index =
-          LineThicknessCB.FindStringExact(((IDataRow) LineSelectCB.SelectedValue).Thickness.ToString());
+          LineThicknessCB.FindStringExact(((IDataRow)LineSelectCB.SelectedValue).Thickness.ToString());
         LineThicknessCB.SelectedIndex = index;
-        index = LinestyleCB.FindStringExact(((IDataRow) LineSelectCB.SelectedValue).Style.ToString());
+        index = LinestyleCB.FindStringExact(((IDataRow)LineSelectCB.SelectedValue).Style.ToString());
         LinestyleCB.SelectedIndex = index;
-        ColorPreviewTB.BackColor = ((IDataRow) LineSelectCB.SelectedValue).Color;
+        ColorPreviewTB.BackColor = ((IDataRow)LineSelectCB.SelectedValue).Color;
       }
     }
@@ -54,17 +56,44 @@
 
     private void OptionsDialogOkButton_Click(object sender, EventArgs e) {
-      if (LineSelectCB.SelectedValue != null) {
-        ((IDataRow) LineSelectCB.SelectedValue).Thickness = (int) LineThicknessCB.SelectedItem;
-        ((IDataRow) LineSelectCB.SelectedValue).Color = ColorPreviewTB.BackColor;
-        ((IDataRow) LineSelectCB.SelectedValue).Style = (DrawingStyle) LinestyleCB.SelectedItem;
-      }
+      ApplyChanges();
+
       Close();
     }
 
     private void OptionsDialogApplyBtn_Click(object sender, EventArgs e) {
+      ApplyChanges();  
+    }
+
+    private void ApplyChanges() {
       if (LineSelectCB.SelectedValue != null) {
-        ((IDataRow) LineSelectCB.SelectedValue).Thickness = (int) LineThicknessCB.SelectedItem;
-        ((IDataRow) LineSelectCB.SelectedValue).Color = ColorPreviewTB.BackColor;
-        ((IDataRow) LineSelectCB.SelectedValue).Style = (DrawingStyle) LinestyleCB.SelectedItem;
+        ((IDataRow)LineSelectCB.SelectedValue).Thickness = (int)LineThicknessCB.SelectedItem;
+        ((IDataRow)LineSelectCB.SelectedValue).Color = ColorPreviewTB.BackColor;
+        ((IDataRow)LineSelectCB.SelectedValue).Style = (DrawingStyle)LinestyleCB.SelectedItem;
+      }
+
+      lineChart.Invalidate(true);
+    }
+
+    private void btnChangeTitleFont_Click(object sender, EventArgs e) {
+      fdFont.Font = lineChart.Title.Font;
+      fdFont.Color = lineChart.Title.Color;
+
+      DialogResult dr = fdFont.ShowDialog();
+
+      if(dr == DialogResult.OK) {
+        lineChart.Title.Font = fdFont.Font;
+        lineChart.Title.Color = fdFont.Color;
+      }
+    }
+
+    private void btnChangeLegendFont_Click(object sender, EventArgs e) {
+//      fdFont.Font = lineChart.Legend.Font;
+//      fdFont.Color = lineChart.Legend.Color;
+
+      DialogResult dr = fdFont.ShowDialog();
+
+      if (dr == DialogResult.OK) {
+//        lineChart.Legend.Font = fdFont.Font;
+//        lineChart.Legend.Color = fdFont.Color;
       }
     }
Index: trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.resx
===================================================================
--- trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.resx	(revision 1242)
+++ trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.resx	(revision 1328)
@@ -118,3 +118,6 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
+  <metadata name="fdFont.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
 </root>